from pandac.PandaModules import *
from direct.task import Task
from random import *
from random import random as r
from simulation.weapon import *


        

class Graph:
    
    PROXIMITY = 200
    CONNECTIONS_PER_POINT = 5
    
    def __init__(self,points):
        s = self.PROXIMITY
        self.tiles = {}
        for point in points:
            pos = (int(point[0]/s),
                   int(point[1]/s),
                   int(point[2]/s))
            if pos in self.tiles :
                #if len(self.tiles[pos]) < self.CONNECTIONS_PER_POINT:
                #    self.tiles[pos].append(point)
                pass
            else:
                self.tiles[pos] = [point]
        #print self.tiles
        self.closest = {}
        for pos,tile in self.tiles.iteritems(): 
            for point in tile:
                x,y,z = pos
                reachablePoints = []
                for dx in (-1,0,1):
                    for dy in (-1,0,1):
                        for dz in (-1,0,1):
                            if (x+dx,y+dy,z+dz) in self.tiles:
                                points = self.tiles[(x+dx,y+dy,z+dz)]
                                reachablePoints.extend(points)  
                                
                                
                self.closest[point] = []
                   
                for reachablePoint in reachablePoints:
                    if reachablePoint != point:
                        self.closest[point].append(reachablePoint)    
               
        print self.tiles         
                 
    def getPoint(self,position):
        s = self.PROXIMITY
        pos = (int(position[0]/s),
                   int(position[1]/s),
                   int(position[2]/s))
        if pos in self.tiles:
            return choice(self.tiles[pos])        
        return self.closestPoint(position,self.closest.keys())
        
    
    def closestPoint(self,position,points):
        minDist = 999999999
        pick = None
        for point in points:
            thisDist = (position-point).length()
            if thisDist < minDist:
                minDist = thisDist
                pick = point
        return pick 
        
    def stuck(self,point,node):
        if point in self.closest:
            return choice(self.closest[point])
        else:
            return self.getPoint(pos)
        
    def getNextPoint(self,point,node):
        # try to pick points in the direction of the node
        if point in self.closest:
            #return choice(self.closest[point])
            p = node.getPos()
            node.setPos(node,Vec3(0,10000,0))
            foward = node.getPos()
            node.setPos(p)
            goto =  self.closestPoint(foward,self.closest[point])
            assert goto != None
            assert goto != point
            return goto
                        
        else:
            print "odd point!"
            return self.getPoint(pos)
        
                 
    def generate(self):
        self.lines = LineSegs()
        
        for root,points in self.closest.iteritems():
            
            self.lines.setColor(1,1,1) 
            print "D",root
            for point in points:                
                self.lines.moveTo(root)
                self.lines.drawTo(point)                
                print "A\t",point
                    
        self.lines.setThickness(6)
        geom = self.lines.create()#.reparentTo(render)
        nodepath = NodePath("complex lines")
        nodepath.attachNewNode(geom)
        nodepath.show()
        nodepath.reparentTo(render)            
        nodepath.ls() 
        nodepath.analyze()       
               
              
class PointFollower:
    
    def __init__(self,game):
        self.game = game
        self.graph = game.aiGraph        
        self.reset()
        
    def reset(self):
        self.torget = None
        self.fired = 0
        self.lastPos = Vec3(0,0,0)
        self.lastPosTime = 0
        self.navPoint = Point3(0,0,0)
        
        
        
    def takeShip(self,ship):
        self.ship = ship
        ship.pilot = self
       
    
    def think(self,dt):
                
        if self.torget == None:
            self.torget = self.graph.getPoint(self.ship.node.getPos())
    
        dist = (-self.navPoint + self.torget)*.03
        self.navPoint += dist
       
        self.ship.node.lookAt(Point3(self.navPoint))
        
        if (self.torget - self.ship.node.getPos()).length() < self.ship.speed:
            self.torget = self.graph.getNextPoint(self.torget,self.ship.node)
            
        self.lastPosTime += dt
        if self.lastPosTime > 5:
            self.lastPosTime = 0
            if (self.lastPos-self.ship.node.getPos()).length() < self.ship.speed :
                print "stuck",self.ship.id
                self.torget = self.graph.stuck(self.torget,self.ship.node)
            self.lastPos = self.ship.node.getPos()
            
        if self.torget != None:
            #self.ship.node.setHpr(self.ship.node.getHpr() + Vec3(r()*2-1,r()*2-1,r()*2-1) )
            self.ship.speed = 126
            
            if (self.torget - self.ship.node.getPos()).length() < 500 :
                self.fired += dt
                if self.fired > 1:
                    self.fired = 0
                    self.ship.world.fire(self.ship,Projectile())

       
class Stalker:
    
    def __init__(self,game):
        self.game = game
        self.graph = game.aiGraph
        self.reset()
        
    def reset(self):
        self.torget = None
        self.fired = 0
        self.lastPos = Vec3(0,0,0)
        self.lastPosTime = 0
        self.navPoint = Point3(0,0,0)
        self.flying = True
        
    def takeShip(self,ship):
        self.ship = ship
        ship.pilot = self
    
    def closestShip(self,position):
        minDist = 999999999
        pick = None
        for ship in self.game.world.ships.values():
            if ship.id != self.ship.id:
                thisDist = (position-ship.node.getPos()).length()
                if thisDist < minDist:
                    minDist = thisDist
                    pick = ship
        return minDist,pick    
    
    def think(self,dt):
        
        
        self.ship.speed = 126
           
        dist,closestShip = self.closestShip(self.ship.node.getPos())
        if dist < 800  and dist > 300:            
            #print self.ship.id,dist,closestShip
            self.ship.node.lookAt(closestShip.node.getPos())
            self.fired += dt
            if self.fired > .1:
                self.fired = 0
                self.ship.world.fire(self.ship,Projectile())
            self.ship.speed = 67
        
        else:
            if dist > 300:
                self.ship.speed = 300
                     
            if self.torget == None:
                self.torget = self.graph.getPoint(self.ship.node.getPos())
            dist = (-self.navPoint + self.torget)*.03
            self.navPoint += dist
            self.ship.node.lookAt(Point3(self.navPoint))
            if (self.torget - self.ship.node.getPos()).length() < self.ship.speed:
                self.torget = self.graph.getNextPoint(self.torget,self.ship.node)
            self.lastPosTime += dt
            if self.lastPosTime > 5:
                self.lastPosTime = 0
                if (self.lastPos-self.ship.node.getPos()).length() < self.ship.speed :
                    #print "stuck",self.ship.id
                    self.torget = self.graph.stuck(self.torget,self.ship.node)
                self.lastPos = self.ship.node.getPos()
                
      
            
         