from random import *
import os
from direct.task import Task
from direct.showbase.DirectObject import DirectObject
import direct.directbase.DirectStart
from pandac.PandaModules import *
from simulation.collisions import CollisionDetection

#MODELS = '../../data/models/'
MODELS = 'data/models/'

class ShipLoader:
    def __init__(self):
        self.ships = {}
        self.bstg = {}
        self.rgba = {}
       
        
    def cacheModel(self, modelName):
        self.ships[modelName] = loader.loadModel(MODELS+modelName)
        self.bstg[modelName] = loader.loadTexture(MODELS+modelName+'-bstg.png')
        self.rgba[modelName] = loader.loadTexture(MODELS+modelName+'-rgba.png')
            
    def loadShip(self, modelName):
        geomNodeCollection = self.ships[modelName].findAllMatches('**/+GeomNode')
        shipNode = render.attachNewNode(modelName+'-instance')
        
        for nodePath in geomNodeCollection.asList():
            name = nodePath.node().getName()
            if name == "": name="hull"
            newNode = GeomNode(name)
            geomNodes = nodePath.node()
            for i in range(geomNodes.getNumGeoms()):
                newNode.addGeom(geomNodes.modifyGeom(i))
                shipNode.attachNewNode(newNode)
        shipNode.setTexture(self.rgba[modelName])
        #shipNode.setTexture(self.bstg[modelName])
        shipNode.findAllMatches('**/engine*').hide() 
        shipNode.findAllMatches('**/tur*').hide()
        try:
            shipNode.findAllMatches('**/*low*').detach()
            shipNode.findAllMatches('**/break*').hide()
            shipNode.findAllMatches('**/shield*').detach()
            shipNode.findAllMatches('**/*tor*').hide()
        except:
            pass
      
        
        return shipNode
    
if __name__ == '__main__':
    ships = ShipLoader()
    ships.cacheModel('sword')
    sword = ships.loadShip('sword')
    sword.ls()
    run()